; 
    include \masm32\include\masm32rt.inc
    .686
    include \masm32\macros\timers.asm

; 
; Entry ECX = Unsigned value of duration in milliseconds
; EDX = Pointer to ASCII output.

.data
  Divisors  dd  3600000, 60000, 1
  HrsFmt    db  "%d:", 0
  MinFmt    db  "%02d:", 0
  SecFmt    db  "%06d", 0
  Formats   dd  HrsFmt, MinFmt, SecFmt
  buff db 100 dup(0)
.code

Bin2Time proc
    push    edi
    push    esi
    push    ebx

    push    edx

    mov     esi, OFFSET Divisors
    mov     edi, edx
    mov     ebx, OFFSET Formats
    mov     edx, ecx
    xor     ecx, ecx
    mov     [edi], cl
    mov     cl, 3
  L18:
    push    ecx
    lodsd
    mov     ecx, eax
    mov     eax, edx
    xor     edx, edx
    idiv    ecx
    pop     ecx
    and     eax, eax
    jnz     L2C

    test    ch, 1
    je      L41
  L2C:
    or      ch, 1
    push    ecx
    push    edx
    ;push    eax
    ;push    dword ptr [ebx]
    ;push    edi
    ;call    wsprintfA
    ;add     esp, 0Ch
    add     edi, eax
    pop     edx
    pop     ecx
  L41:
    add     ebx, 4
    dec     cl
    jnz     L18

    pop     edx

    sub     edi, eax
    mov     esi, edi
    inc     esi
    lodsw
    stosw
    mov     al, 2Eh
    stosb

    cmp     byte ptr [edx], 30h
    jnz     L5B
    inc     edx
  L5B:
    pop     ebx
    pop     esi
    pop     edi
    ret
Bin2Time endp

; 

.data
    szUptimeFmt DB "%u days %02u:%02u:%02u.%u",0
.code
UpTime proc uses edx pszTimeString:DWORD, milliseconds:DWORD
    LOCAL Minutes:DWORD
    LOCAL Hours:DWORD
    LOCAL Days:DWORD

    xor ebx,ebx
    ;invoke GetTickCount
    mov eax, milliseconds

    xor edx,edx
    mov ecx,86400000 ; Milliseconds in one day
    div ecx
    mov [Days],eax

    mov eax,edx
    xor edx,edx
    mov ecx,3600000 ; Milliseconds in one hour
    div ecx
    mov [Hours],eax

    mov eax,edx
    xor edx,edx
    mov ecx,60000 ; Milliseconds in one minute

    div ecx
    mov [Minutes],eax

    ; convert to seconds with fraction
    push edx
    pop eax
    xor edx,edx
    mov ecx,1000
    div ecx

    ;invoke wsprintf,pszTimeString,ADDR szUptimeFmt,Days,Hours,Minutes,eax,edx

    ret
UpTime endp

; 
ALIGN 16

.data
    ElapsDays    dd 0
    ElapsHours   dd 0
    ElapsMinutes dd 0
    ElapsSeconds dd 0
.code

ALIGN 16
UpTime2 PROC
push ebx
push esi
	mov esi,edx

; diviser par 1000 (pour rduire la valeur  jours/heures/minutes/secondes)
		mov eax,2199023256								;; ) diviser par le nombre de millisecondes (1000) (vrifi de 0  FFFFFFFFh)
		mul ecx										;; )
		shr edx,9										;; )
		mov ecx,edx									;; copier le rsultat dans ecx

; obtenir le nombre de jours et d'heures
		mov eax,2443359173								;; ) diviser par le nombre d'heures (3600) (vrifi de 0  4320000)
		mul edx										;; )
		shr edx,11									;; )
		mov ebx,edx									;; placer le nombre d'heures et de jours dans ebx
		mov eax,3600									;;	) soustraire le nombre de jours et d'heures obtenus  notre sauvegarde
		mul edx										;;	)
		sub ecx,eax									;; placer le nombre de minutes et de secondes dans ecx

; obtenir le nombre de jours
		mov eax,178956971								;; ) diviser par le nombre d'heures (24) (vrifi de 0  1200)
		mul ebx										;; )
		mov [esi],edx									;; sauvegarder le nombre de jours
; obtenir le nombre d'heures
	lea edx,[edx+edx*2]
	shl edx,3
	sub ebx,edx
;		mov eax,24									;;	) soustraire le nombre de jours obtenus  notre sauvegarde
;		mul edx										;;	)
;		sub ebx,eax									;;	)
		mov [esi+4],ebx								;; sauvegarder le nombre d'heures

; obtenir le nombre de minutes
		mov eax,71582789								;; ) diviser par le nombre de secondes (60) (vrifi de 0  3600)
		mul ecx										;; )
		mov [esi+8],edx								;; sauvegarder le nombre de minutes
; obtenir le nombre de secondes
	lea edx,[edx+edx*4]
	lea edx,[edx+edx*2]
	shl edx,2
	sub ecx,edx
;		mov eax,60									;;	) soustraire le nombre de minutes obtenues  notre sauvegarde
;		mul edx										;;	)
;		sub ecx,eax									;;	)
		mov [esi+12],ecx								;; sauvegarder le nombre de secondes

pop esi
pop ebx
	ret												;; retourner (sortir de la procdure)
UpTime2 ENDP

; 
ALIGN 16

.data
    days    dd 0
    hours   dd 0
    minutes dd 0
    seconds dd 0
.code

option prologue:none            ; turn it off
option epilogue:none            ;
align  16                       ;
d2dtl  proc    lpointTimeBuffer : DWORD, ntime:DWORD
       mov     eax, [esp+2*4]   ; eax-> time in miliseconds
       mov     ecx, 31B5D4h     ; 2^48 / 86400000
       mov     [esp+2*4], esi   ; saving esi
       mul     ecx              ; high 16 bits of edx = days, dx:eax = fractional days(hours,mins,sec)
       mov     esi, [esp+1*4]   ; esi->lpTimeBuffer
       mov     ecx, edx         ; high 16 bits of ecx-> days
       mov     [esp+1*4], ebx   ; saving ebx
       shr     ecx, 16          ; edx-> days
       mov     [esi], ecx       ; saving days
       and     edx, 0FFFFh      ; edx-> fractional days
       mov     ebx, eax         ;
       mov     ecx, edx         ;
       add     eax, eax         ;
       adc     edx, edx         ;
       add     eax, ebx         ;
       adc     edx, ecx         ;
       shrd    eax, edx, 13     ;
       shr     edx, 13          ; edx = hours, eax = fractions(min,sec)
       mov     ebx, eax         ;
       shr     ebx, 4           ;
       mov     [esi+4], edx     ; saving hours
       sub     eax, ebx         ;
       mov     ebx, eax         ;
       and     eax, 03FFFFFFh   ; eax-> low 26 bits;(min:sec)
       shr     ebx, 26          ;
       mov     edx, eax         ;
       shr     edx, 4           ;
       mov     [esi+8], ebx     ; saving minutes
       sub     eax, edx         ;
       mov     ebx, [esp+1*4]   ; restoring ebx
       shr     eax, 20          ;
       mov     [esi+12], eax    ; saving seconds
       mov     esi, [esp+2*4]   ; restoring esi
       ret     2*4              ;
d2dtl  endp                     ;
option prologue:prologuedef     ;  turn back on the defaults
option epilogue:epiloguedef     ;




; 
start:
; 
    comment | function tests
    mov ecx, 12345678
    mov edx, OFFSET buff
    call Bin2Time
    print ADDR buff,13,10

    invoke UpTime, ADDR buff, 12345678
    print ADDR buff,13,10

    invoke d2dtl, ADDR days, 12345678
    print ustr$(days),":"
    print ustr$(hours),":"
    print ustr$(minutes),":"
    print ustr$(seconds),13,10
    |

    invoke Sleep, 3000

    counter_begin 1000, HIGH_PRIORITY_CLASS
      mov ecx, 12345678
      mov edx, OFFSET buff
      call Bin2Time
    counter_end
    print ustr$(eax)," cycles",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      invoke UpTime, ADDR buff, 12345678
    counter_end
    print ustr$(eax)," cycles",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      mov ecx, 12345678
      mov edx, OFFSET ElapsDays
      call UpTime2
    counter_end
    print ustr$(eax)," cycles",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      invoke d2dtl, ADDR days, 12345678
    counter_end
    print ustr$(eax)," cycles",13,10

    inkey "Press any key to exit..."
    exit
; 
end start



